#include <error.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

/* This will be running setgid, so be careful! */

extern const char *__progname;

void	my_error_print_progname( void )
{
	fflush( stdout );
	fprintf( stderr, "%s: ", __progname );
	fflush( stderr );
}

void usage(void)
{
	fprintf( stderr, "usage: %s [-r]\n", *__progname ? __progname : "netreport" );
	exit(1);
}

#define ADD 1
#define DEL 0

int main( int argc, char *argv[] )
{
	int action = ADD;
	const char prefix[] = "/var/run/netreport/";
	char netreport_name[ sizeof(prefix) + 3 * sizeof( unsigned ) ];

	error_print_progname = my_error_print_progname;

	if ( argc < 1 || argc > 2 )
		usage();

	if ( argc > 1 )
	{
		if ( !strcmp( argv[1], "-r" ) )
			action = DEL;
		else
			usage();
	}

	snprintf( netreport_name, sizeof(netreport_name), "%s%u", prefix, getppid() );
	if ( ADD == action )
	{
		int netreport_file = creat( netreport_name, 0 );
		if ( netreport_file < 0 )
		{
			if ( errno != EEXIST )
				error( EXIT_FAILURE, errno, "could not create netreport file" );
		} else
			close( netreport_file );
	} else
	{
		if ( unlink( netreport_name ) < 0 )
			error( EXIT_FAILURE, errno, "could not remove netreport file" );
	}

	return 0;
}
